local cfg -- config we'll define later
local addon, ns = ... --get addon namespace

local HELM, NECK, SHOULDER, SHIRT, CHEST, WAIST, LEGS, FEET, WRISTS, HANDS, RING1, RING2, TRINK1, TRINK2, BACK, WEP, OFFHAND = 1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17
local ORole = {
	["TANK"]   = {"Interface\\LFGFrame\\LFGRole", 0.5, 0.75, 0, 1},
	["HEALER"] = {"Interface\\LFGFrame\\LFGRole", 0.75, 1, 0, 1},
	["DAMAGER"] = {"Interface\\LFGFrame\\LFGRole", 0.25, 0.5, 0, 1},
	["NONE"] = {"",0,0,0,0}
}
local ORank = {
	[0] = {""},
	[1] = {"Interface\\GROUPFRAME\\UI-GROUP-ASSISTANTICON"},
	[2] = {"Interface\\GROUPFRAME\\UI-Group-LeaderIcon"},
}
local Oilvlrole = {};
local Oilvlrank = {};
local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local Oilvltimer = LibStub("AceAddon-3.0"):NewAddon("MyAddOn", "AceTimer-3.0")

local OILVL = CreateFrame("Frame");
local oilvlframesw=false;
local oilvlframedata = {};
oilvlframedata.guid = {};
oilvlframedata.name = {};
oilvlframedata.ilvl = {};
local OILVL_Unit="";
local OTilvl=0;
local OTmia=0;
local OTTop=0;	
local Omover=0;
local OTCurrent=""; -- current raid frame
local OTCurrent2=""; -- current unit id
local OTCurrent3=""; -- current raid frame number
local ountrack=true;
local ail=0; -- average item level
local miacount=0;
local miaunit={};

-- OT Check Raid Item Level
function oilvl(unit)
	if not UnitAffectingCombat("player") then
		OILVL_Unit=unit;
		if CheckInteractDistance(OILVL_Unit, 1) and CanInspect(OILVL_Unit) then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect(OILVL_Unit);
			local htex4 = _G[OTCurrent]:CreateTexture()
			htex4:SetTexture(0,1,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			_G[OTCurrent]:SetNormalTexture(htex4)
		else
			OILVL_Unit="";
			miacount=0;
			miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
			local ntex4 = _G[OTCurrent]:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			_G[OTCurrent]:SetNormalTexture(ntex4)
			OTCurrent = "";
			OTCurrent2 = "";
			OTCurrent3 = "";
			ountrack=true;			
		end
	end
end
	
-- Get Raid Frame Item Level
function ORfbIlvl(ounit)
if not UnitAffectingCombat("player") then
	local i=0;
	OTCurrent3 = ounit-0;
	if IsInRaid() then
		OTCurrent = "OILVLRAIDFRAME"..ounit;		
		OTCurrent2 = "raid"..ounit;
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvl(OTCurrent2);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		if ounit == "1" or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(ounit-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvl(OTCurrent2);
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		if ounit == "1"  or ounit == 1 then
			OTCurrent = "OILVLRAIDFRAME1";
			OTCurrent2 = "player";
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvl(OTCurrent2);
			end
		else
			OTCurrent = "OILVLRAIDFRAME"..ounit;
			OTCurrent2 = "party"..(ounit-1);
			if GetUnitName(OTCurrent2,"") ~= nil then
				_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
				oilvl(OTCurrent2);
			end
		end
	else
		OTCurrent = "OILVLRAIDFRAME1";
		OTCurrent2 = "player";
		if GetUnitName(OTCurrent2,"") ~= nil then
			_G[OTCurrent]:SetText("|cFFFFFF00"..GetUnitName(OTCurrent2,""):gsub("%-.+", ""));
			oilvl(OTCurrent2);
		end
	end
end
end

function OilvlSetRole(ounit, orole)
	Oilvlrole[ounit]:SetTexture(ORole[orole][1]);
	Oilvlrole[ounit]:SetTexCoord(ORole[orole][2],ORole[orole][3],ORole[orole][4],ORole[orole][5]);
end

function OilvlSetRank(ounit, orole)
	Oilvlrank[ounit]:SetTexture(ORank[orole][1]);
end

function OilvlSetMouseoverTooltips(oframe, ounit)
	oframe:SetAttribute("unit", ounit)
	oframe:SetScript("OnEnter", function(self) 
	GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
	GameTooltip:SetUnit(ounit) 
	GameTooltip:Show() 
	end) 
end

function oilvlcheckunknown()
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("raid"..i,""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("raid"..i);
				oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
				oilvlframedata.ilvl[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = 2, rnum do
			if oilvlframedata.name[i] == "Unknown" then
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
				_G["OILVLRAIDFRAME"..i]:Show();
				oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
				oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
				oilvlframedata.ilvl[i] = "";
			end
		end
	else
		return 0
	end
end

function OILVLCheckUpdate()
if not UnitAffectingCombat("player") and OILVL_Unit == "" then
	oilvlcheckunknown();
	ountrack=false;
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i] then break; end
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00",""):gsub("\n|r|cFF00FF00",":"):gsub("\n|r|cFFFF0000",":");
		local ochar, ilvl = strsplit(":",msg,2)	
		if ilvl == nil or ilvl == "" then
			ountrack = true;
			if IsInRaid() then
				if CheckInteractDistance("raid"..i, 1) and CanInspect("raid"..i) then ORfbIlvl(i); return 0; end
			elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
				if i == 1 then
					ORfbIlvl(i); return 0;
				else
					if CheckInteractDistance("party"..(i-1), 1) and CanInspect("party"..(i-1)) then ORfbIlvl(i); return 0; end
				end
			else
				ORfbIlvl(1); return 0;
			end
		end
	end	
end
end
	
function OVILRefresh()
if not UnitAffectingCombat("player") then
	local i=0;
	local rnum=0;
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	for i = 1, 40 do
		-- reset the color of all frames
		local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
		ntex4:SetTexture(0.2,0.2,0.2,0.5)
		ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
		ntex4:SetAllPoints()	
		_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)			
		
		-- reset data
		oilvlframedata.guid[i] = "";
		oilvlframedata.name[i] = "";
		oilvlframedata.ilvl[i] = "";
	end
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(266);
		end
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end
		for i = rnum+1, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		for i = 1, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("raid"..i,""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = UnitGUID("raid"..i);
			oilvlframedata.name[i] = GetUnitName("raid"..i,""):gsub("%-.+", "");
			oilvlframedata.ilvl[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
		for i = rnum, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(266);
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
		for i = rnum, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		OILVLRAIDFRAME1:Show();
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
		for i = 2, rnum do
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..GetUnitName("party"..(i-1),""):gsub("%-.+", ""));
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
			if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
			oilvlframedata.guid[i] = UnitGUID("party"..(i-1));
			oilvlframedata.name[i] = GetUnitName("party"..(i-1),""):gsub("%-.+", "")
			oilvlframedata.ilvl[i] = "";
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
		end
		OIVLFRAME:SetWidth(266);
	else
		for i = 2, 40 do
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(266);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
end
-- Same as OVILRefresh(), but do not clear item level.
function OilvlCheckFrame()
if not UnitAffectingCombat("player") then
	local i=0;
	local j=0;
	local rnum=0;
	local td = {};
	td.guid = {};
	td.name = {};
	td.ilvl = {};
	for i=1,40 do
		td.guid[i] = "";
		td.name[i] = "";
		td.ilvl[i] = "";
	end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
	OILVL_Unit="";
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		if rnum < 16 then
			OIVLFRAME:SetWidth(266);
		end		
		if rnum >= 16 and rnum <= 20 then
			OIVLFRAME:SetWidth(348);
		end
		if rnum >= 21 and rnum <= 25 then
			OIVLFRAME:SetWidth(430);
		end
		if rnum >= 26 and rnum <= 30 then
			OIVLFRAME:SetWidth(512);
		end
		if rnum >= 31 and rnum <= 35 then
			OIVLFRAME:SetWidth(594);
		end
		if rnum >= 36 and rnum <= 40 then
			OIVLFRAME:SetWidth(676);
		end

		for j=1, rnum do
			for i=1, 40 do
				if oilvlframedata.guid[i] == "" then break end
				if UnitGUID("raid"..j) == oilvlframedata.guid[i] then
					td.guid[j] = oilvlframedata.guid[i];
					td.name[j] = oilvlframedata.name[i];
					td.ilvl[j] = oilvlframedata.ilvl[i];
					break;
				end
			end
			if td.guid[j] == "" then
				td.guid[j] = UnitGUID("raid"..j);
				td.name[j] = GetUnitName("raid"..j,""):gsub("%-.+", "");
				td.ilvl[j] = "";
			end
		end

		for i = rnum+1, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		for i = 1, rnum do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
			_G["OILVLRAIDFRAME"..i]:Show();
			OilvlSetRole(i, UnitGroupRolesAssigned("raid"..i,""));
			local _, rank, _, _, _, _, _, _, _, _, _ = GetRaidRosterInfo(i)
			OilvlSetRank(i, rank);
			oilvlframedata.guid[i] = td.guid[i];
			oilvlframedata.name[i] = td.name[i];
			oilvlframedata.ilvl[i] = td.ilvl[i];
			OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "raid"..i);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1		
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
			end
			OILVLRAIDFRAME1:Show();
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(266);
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		if rnum > 0 then
			for j=1, rnum do
				for i=2, 5 do
					if oilvlframedata.guid[i] == "" then break end
					if UnitGUID("party"..j) == oilvlframedata.guid[i] then
						td.guid[j+1] = oilvlframedata.guid[i];
						td.name[j+1] = oilvlframedata.name[i];
						td.ilvl[j+1] = oilvlframedata.ilvl[i];
						break;
					end
				end
				if td.guid[j+1] == "" then
					td.guid[j+1] = UnitGUID("party"..j);
					td.name[j+1] = GetUnitName("party"..j,""):gsub("%-.+", "");
					td.ilvl[j+1] = "";
				end
			end
			for i = rnum+1, 40 do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("");
				_G["OILVLRAIDFRAME"..i]:Hide();
				oilvlframedata.guid[i] = "";
				oilvlframedata.name[i] = "";
				oilvlframedata.ilvl[i] = "";
			end
			OILVLRAIDFRAME1:Show();
			OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
			OilvlSetRole(1, UnitGroupRolesAssigned("player"));
			if UnitIsGroupLeader("player") then	OilvlSetRank(1, 2);	else OilvlSetRank(1, 0); end
			for i = 2, (rnum+1) do
				if not _G["OILVLRAIDFRAME"..i]  then break; end
				_G["OILVLRAIDFRAME"..i]:SetText("|cFFFFFF00"..td.name[i].."\n|r|cFF00FF00"..td.ilvl[i]);
				_G["OILVLRAIDFRAME"..i]:Show();
				OilvlSetRole(i, UnitGroupRolesAssigned("party"..(i-1),""));
				if UnitIsGroupLeader("party"..(i-1)) then OilvlSetRank(i, 2); else OilvlSetRank(i, 0); end
				oilvlframedata.guid[i] = td.guid[i];
				oilvlframedata.name[i] = td.name[i];
				oilvlframedata.ilvl[i] = td.ilvl[i];
				OilvlSetMouseoverTooltips(_G["OILVLRAIDFRAME"..i], "party"..(i-1));
			end
			OIVLFRAME:SetWidth(266);
		end
	else
		OIVLFRAME:SetWidth(266);
		for i = 2, 40 do
			if not _G["OILVLRAIDFRAME"..i]  then break; end
			_G["OILVLRAIDFRAME"..i]:SetText("");
			_G["OILVLRAIDFRAME"..i]:Hide();
			oilvlframedata.guid[i] = "";
			oilvlframedata.name[i] = "";
			oilvlframedata.ilvl[i] = "";
		end
		OILVLRAIDFRAME1:SetText("|cFFFFFF00"..GetUnitName("player",""):gsub("%-.+", ""));
		OilvlSetRole(1, UnitGroupRolesAssigned("player"));
		OilvlSetRank(1, 0);
		OIVLFRAME:SetWidth(266);
		oilvlframedata.guid[1] = UnitGUID("player");
		oilvlframedata.name[1] = GetUnitName("player",""):gsub("%-.+", "");
		oilvlframedata.ilvl[1] = "";
		OilvlSetMouseoverTooltips(OILVLRAIDFRAME1, "player");
	end
end
	ountrack=true;
	OTCurrent=""; -- current raid frame
	OTCurrent2=""; -- current unit id
	OTCurrent3=""; -- current raid frame number
end

local function round(number, digits)
    return tonumber(string.format("%." .. (digits or 0) .. "f", number))
end

function oilvlcheckrange()
if not UnitAffectingCombat("player") then
	local i=0;
	local rnum=0;
	if IsInRaid() then
		rnum = GetNumGroupMembers();
		for i = 1, rnum do
			if not CheckInteractDistance("raid"..i, 1) then
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)
			else
				local ntex4 = _G["OILVLRAIDFRAME"..i]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..i]:SetNormalTexture(ntex4)					
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end
		end
	elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then		
		rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME) - 1
		for i = 1, rnum do
			if not CheckInteractDistance("party"..i, 1) then 
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0,0,0,1)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			else
				local ntex4 = _G["OILVLRAIDFRAME"..(i+1)]:CreateTexture()
				ntex4:SetTexture(0.2,0.2,0.2,0.5)
				ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
				ntex4:SetAllPoints()	
				_G["OILVLRAIDFRAME"..(i+1)]:SetNormalTexture(ntex4)	
			end
		end
	end
	if OTCurrent ~= "" then
		local htex4 = _G[OTCurrent]:CreateTexture()
		htex4:SetTexture(0,1,1,0.5)
		htex4:SetTexCoord(0, 0.625, 0, 0.6875)
		htex4:SetAllPoints()
		_G[OTCurrent]:SetNormalTexture(htex4)	
	end
	if ountrack and not UnitAffectingCombat("player") then
		Oilvltimer:ScheduleTimer(OILVLCheckUpdate,1);
	end
	if OILVL_Unit ~= "" then ORfbIlvl(OTCurrent3); end
-- Calculate Average Item Level
	local total=0;
	local n=0;
	for i = 1, 40 do 
		if oilvlframedata.ilvl[i] ~= "" then 
			n = n + 1;
			total = total + oilvlframedata.ilvl[i];
		end
	end
	if(n ~= 0) then ail = round(total/n,1); end
	if ail then
		OilvlAIL:SetText("Average Item Level: "..ail);
	else
		OilvlAIL:SetText("Average Item Level: 0");
		ail = 0;
	end
end
end

function OSendToTarget()
	local i=0;
	if not UnitExists("target") then 
		return -1;
	end
	SendChatMessage("Item Level:", "WHISPER", nil, UnitName("target"));
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "WHISPER", nil, UnitName("target"));
	end
	SendChatMessage("Average Item Level: "..ail, "WHISPER", nil, UnitName("target"));
end

function OSendToParty()
	local i=0;
	SendChatMessage("Item Level:", "PARTY");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "PARTY");
	end
	SendChatMessage("Average Item Level: "..ail, "PARTY");
end

function OSendToInstance()
	local i=0;
	SendChatMessage("Item Level:", "INSTANCE_CHAT");
	for i = 1, 5 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "INSTANCE_CHAT");
	end
	SendChatMessage("Average Item Level: "..ail, "INSTANCE_CHAT");
end

function OSendToGuild()
	local i=0;
	SendChatMessage("Item Level:", "GUILD");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end		
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "GUILD");
	end
	SendChatMessage("Average Item Level: "..ail, "GUILD");
end

function OSendToRaid()
	local i=0;
	SendChatMessage("Item Level:", "RAID");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "RAID");
	end
	SendChatMessage("Average Item Level: "..ail, "RAID");
end

function OSendToOfficer()
	local i=0;
	SendChatMessage("Item Level:", "OFFICER");
	for i = 1, 40 do
		if not _G["OILVLRAIDFRAME"..i]:IsShown() then
			break;
		end
		local msg = _G["OILVLRAIDFRAME"..i]:GetText();
		if msg == nil then
			break;
		end
		msg = msg:gsub("|cFFFFFF00","");
		msg = msg:gsub("\n|r|cFF00FF00",": ");
		SendChatMessage(msg, "OFFICER");
	end
	SendChatMessage("Average Item Level: "..ail, "OFFICER");
end
	
function oilvlframe()
	local f = CreateFrame("Frame", "OIVLFRAME", UIParent, "ButtonFrameTemplate");
	f:SetWidth(676);
	f:SetHeight(320);
	f:SetFrameStrata("LOW");

-- set moveable and dragable	
	f:SetMovable(true);
	f:EnableMouse(true);
	f:RegisterForDrag("LeftButton");
	f:SetScript("OnDragStart", f.StartMoving);
	f:SetScript("OnDragStop", function() f:StopMovingOrSizing();  cfg.oilvlframeP, _, _, cfg.oilvlframeX, cfg.oilvlframeY = f:GetPoint() end);

-- Set Title
	f.text = f.text or f:CreateFontString(nil,"ARTWORK", "GameTooltipText");
	f.text:SetAllPoints(true);
	f.text:SetPoint("TOPLEFT",0,-6);
	f.text:SetJustifyH("CENTER");
	f.text:SetJustifyV("TOP");
	f.text:SetTextColor(1,1,1,1);
	f.text:SetText("O Item Level");	
	
--background texture
	local t = f:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(0.1,0.1,0.1,0.5)
	t:SetAllPoints(f)
	f.texture = t
	f:SetPoint("TOPLEFT",15,-60);
	
 --icon
    local icon = f:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
    icon:SetSize(60,60);
    icon:SetPoint("TOPLEFT",-5,7);
    icon:SetTexture("Interface\\FriendsFrame\\Battlenet-Portrait");
    icon:SetTexCoord(0,1,0,1);
    f.icon = icon;

-- Average Item Level
	local ail = f:CreateFontString("OilvlAIL","ARTWORK","GameFontHighlight")
	ail:SetPoint("BOTTOMLEFT",10,30)
	ail:SetText("Average Item Level:");
	
--Refresh button
	local button = CreateFrame("Button", "OILVLREFRESH", f)
	button:SetPoint("TOPRIGHT", -6, -35)
	button:SetWidth(60)
	button:SetHeight(22)
	
	button:SetText("Refresh")
	button:SetNormalFontObject("GameFontNormal")
	
	local ntex = button:CreateTexture()
	ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex:SetAllPoints()	
	button:SetNormalTexture(ntex)
	
	local htex = button:CreateTexture()
	htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex:SetTexCoord(0, 0.625, 0, 0.6875)
	htex:SetAllPoints()
	button:SetHighlightTexture(htex)
	
	local ptex = button:CreateTexture()
	ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex:SetAllPoints()
	button:SetPushedTexture(ptex)

	button:RegisterForClicks("LeftButtonDown");
	button:SetScript("OnClick", function(self, button) OVILRefresh() end);

--Party button
	local button6 = CreateFrame("Button", "OILVLParty", f)
	button6:SetPoint("TOPRIGHT", -68, -35)
	button6:SetWidth(60)
	button6:SetHeight(22)
	
	button6:SetText("Party")
	button6:SetNormalFontObject("GameFontNormal")
	
	local ntex6 = button6:CreateTexture()
	ntex6:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex6:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex6:SetAllPoints()	
	button6:SetNormalTexture(ntex6)
	
	local htex6 = button6:CreateTexture()
	htex6:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex6:SetTexCoord(0, 0.625, 0, 0.6875)
	htex6:SetAllPoints()
	button6:SetHighlightTexture(htex6)
	
	local ptex6 = button6:CreateTexture()
	ptex6:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex6:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex6:SetAllPoints()
	button6:SetPushedTexture(ptex6)

	button6:RegisterForClicks("LeftButtonDown");
	button6:SetScript("OnClick", function(self, button) OSendToParty() end);

--Target button
	local button7 = CreateFrame("Button", "OILVLTarget", f)
	button7:SetPoint("TOPRIGHT", -130, -35)
	button7:SetWidth(60)
	button7:SetHeight(22)
	
	button7:SetText("Target")
	button7:SetNormalFontObject("GameFontNormal")
	
	local ntex7 = button7:CreateTexture()
	ntex7:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex7:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex7:SetAllPoints()	
	button7:SetNormalTexture(ntex7)
	
	local htex7 = button7:CreateTexture()
	htex7:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex7:SetTexCoord(0, 0.625, 0, 0.6875)
	htex7:SetAllPoints()
	button7:SetHighlightTexture(htex7)
	
	local ptex7 = button7:CreateTexture()
	ptex7:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex7:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex7:SetAllPoints()
	button7:SetPushedTexture(ptex7)

	button7:RegisterForClicks("LeftButtonDown");
	button7:SetScript("OnClick", function(self, button) OSendToTarget() end);
	
--Instance button
	local button5 = CreateFrame("Button", "OILVLINSTANCE", f)
	button5:SetPoint("BOTTOMLEFT", 3, 3)
	button5:SetWidth(80)
	button5:SetHeight(22)
	
	button5:SetText("Instance")
	button5:SetNormalFontObject("GameFontNormal")
	
	local ntex5 = button5:CreateTexture()
	ntex5:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex5:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex5:SetAllPoints()	
	button5:SetNormalTexture(ntex5)
	
	local htex5 = button5:CreateTexture()
	htex5:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex5:SetTexCoord(0, 0.625, 0, 0.6875)
	htex5:SetAllPoints()
	button5:SetHighlightTexture(htex5)
	
	local ptex5 = button5:CreateTexture()
	ptex5:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex5:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex5:SetAllPoints()
	button5:SetPushedTexture(ptex5)

	button5:RegisterForClicks("LeftButtonDown");
	button5:SetScript("OnClick", function(self, button) OSendToInstance() end);

-- Guild button
	local button2 = CreateFrame("Button", "OILVLGUILD", f)
	button2:SetPoint("BOTTOMLEFT", 85, 3)
	button2:SetWidth(50)
	button2:SetHeight(22)
	
	button2:SetText("Guild")
	button2:SetNormalFontObject("GameFontNormal")
	
	local ntex2 = button2:CreateTexture()
	ntex2:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex2:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex2:SetAllPoints()	
	button2:SetNormalTexture(ntex2)
	
	local htex2 = button2:CreateTexture()
	htex2:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex2:SetTexCoord(0, 0.625, 0, 0.6875)
	htex2:SetAllPoints()
	button2:SetHighlightTexture(htex2)
	
	local ptex2 = button2:CreateTexture()
	ptex2:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex2:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex2:SetAllPoints()
	button2:SetPushedTexture(ptex2)

	button2:RegisterForClicks("LeftButtonDown");
	button2:SetScript("OnClick", function(self, button) OSendToGuild()	end);
	
-- Raid button
	local button3 = CreateFrame("Button", "OILVLRAID", f)
	button3:SetPoint("BOTTOMLEFT", 137, 3)
	button3:SetWidth(50)
	button3:SetHeight(22)
	
	button3:SetText("Raid")
	button3:SetNormalFontObject("GameFontNormal")
	
	local ntex3 = button3:CreateTexture()
	ntex3:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ntex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ntex3:SetAllPoints()	
	button3:SetNormalTexture(ntex3)
	
	local htex3 = button3:CreateTexture()
	htex3:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	htex3:SetTexCoord(0, 0.625, 0, 0.6875)
	htex3:SetAllPoints()
	button3:SetHighlightTexture(htex3)
	
	local ptex3 = button3:CreateTexture()
	ptex3:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	ptex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ptex3:SetAllPoints()
	button3:SetPushedTexture(ptex3)

	button3:RegisterForClicks("LeftButtonDown");
	button3:SetScript("OnClick", function(self, button) OSendToRaid()	end);

-- Officer button
	local Oofficer = CreateFrame("Button", "OILVLRAID", f)
	Oofficer:SetPoint("BOTTOMLEFT", 190, 3)
	Oofficer:SetWidth(60)
	Oofficer:SetHeight(22)
	
	Oofficer:SetText("Officer")
	Oofficer:SetNormalFontObject("GameFontNormal")
	
	local ontex3 = Oofficer:CreateTexture()
	ontex3:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
	ontex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ontex3:SetAllPoints()	
	Oofficer:SetNormalTexture(ontex3)
	
	local ohtex3 = Oofficer:CreateTexture()
	ohtex3:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
	ohtex3:SetTexCoord(0, 0.625, 0, 0.6875)
	ohtex3:SetAllPoints()
	Oofficer:SetHighlightTexture(ohtex3)
	
	local optex3 = Oofficer:CreateTexture()
	optex3:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
	optex3:SetTexCoord(0, 0.625, 0, 0.6875)
	optex3:SetAllPoints()
	Oofficer:SetPushedTexture(optex3)

	Oofficer:RegisterForClicks("LeftButtonDown");
	Oofficer:SetScript("OnClick", function(self, button) OSendToOfficer()	end);

-- Party / Raid Frame
	local rfb=1; -- raid frame button
	local b4i=0;
	local b4j=0;
	for b4j = 1, 8 do
		for b4i = 1, 5 do
			local button4 = CreateFrame("Button", "OILVLRAIDFRAME"..rfb, f, "SecureActionButtonTemplate")
			button4:SetPoint("TOPLEFT", 10+(b4j-1)*82, -66-(b4i-1)*42)
			button4:SetWidth(80)
			button4:SetHeight(40)	
			button4:SetText("")
			button4:SetNormalFontObject("GameFontNormal")			
	
			local ntex4 = button4:CreateTexture()
			ntex4:SetTexture(0.2,0.2,0.2,0.5)
			ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ntex4:SetAllPoints()	
			button4:SetNormalTexture(ntex4)
	
			local htex4 = button4:CreateTexture()
			htex4:SetTexture(0,0,1,0.5)
			htex4:SetTexCoord(0, 0.625, 0, 0.6875)
			htex4:SetAllPoints()
			button4:SetHighlightTexture(htex4)
	
			local ptex4 = button4:CreateTexture()
			ptex4:SetTexture(0,1,1,0.5)
			ptex4:SetTexCoord(0, 0.625, 0, 0.6875)
			ptex4:SetAllPoints()
			button4:SetPushedTexture(ptex4)
		
			-- Left Click
			button4:RegisterForClicks("LeftButtonDown", "RightButtonDown");
			button4:SetScript("PostClick", function(self, button, down) 
					ORfbIlvl(self:GetName():gsub("OILVLRAIDFRAME", "").."") 
			end);
			
			-- Right Click
			button4:SetAttribute("type2", "target");
			button4:SetAttribute("target", "mouseover");
			
			-- hide tooltips
			button4:SetScript("OnLeave", function(self) GameTooltip:Hide() end)

			-- set role variable
			Oilvlrole[rfb] = button4:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
			Oilvlrole[rfb]:SetSize(15,15);
			Oilvlrole[rfb]:SetPoint("BOTTOMRIGHT",0,0);
			Oilvlrole[rfb]:SetTexture(nil);
			Oilvlrole[rfb]:SetTexCoord(0,0,0,0);
			-- set rank variable
			Oilvlrank[rfb] = button4:CreateTexture("$parentIcon", "OVERLAY", nil, -8);
			Oilvlrank[rfb]:SetSize(15,15);
			Oilvlrank[rfb]:SetPoint("TOPLEFT",0,5);
			Oilvlrank[rfb]:SetTexture(nil);
--			Oilvlrank[rfb]:SetTexCoord(0,0,0,0);
			
			rfb = rfb + 1;
		end
	end	
-- Refresh
	oilvlframesw=true;
	OVILRefresh();
	f:SetScale(0.8);
	f:Hide();
--	tinsert(UISpecialFrames,"OIVLFRAME");
--	f:SetUserPlaced(true);
end

function GetStatisticId(CategoryTitle, StatisticTitle)
	local str = ""
	for _, CategoryId in pairs(GetStatisticsCategoryList()) do
		local Title, ParentCategoryId, Something
		Title, ParentCategoryId, Something = GetCategoryInfo(CategoryId)
		
		if Title == CategoryTitle then
			local i
			local statisticCount = GetCategoryNumAchievements(CategoryId)
			for i = 1, statisticCount do
				local IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText
				IDNumber, Name, Points, Completed, Month, Day, Year, Description, Flags, Image, RewardText = GetAchievementInfo(CategoryId, i)
				if Name == StatisticTitle then
					return IDNumber
				end
			end
		end
	end
	return -1
end

function OGetComA()
	-- SoO Data
	local OSTAT = {
	--	[#] = {LFR,Normal,{10H,25H},{10H,25H}}
		[1]	= {8549,8550,{8551,8552},{8553,8554}},
		[2]	= {8555,8556,{8557,8558},{8559,8560}},
		[3]	= {8561,8562,{8563,8564},{8565,8566}},
		[4]	= {8567,8568,{8569,8570},{8571,8573}},
		[5]	= {8574,8575,{8576,8577},{8578,8579}},
		[6]	= {8580,8581,{8582,8583},{8584,8585}},
		[7]	= {8586,8587,{8588,8589},{8590,8591}},
		[8]	= {8593,8594,{8595,8596},{8597,8598}},
		[9]	= {8599,8600,{8601,8602},{8603,8604}},
		[10]= {8605,8606,{8608,8609},{8610,8612}},
		[11]= {8614,8615,{8616,8617},{8618,8619}},
		[12]= {8620,8621,{8622,8623},{8624,8625}},
		[13]= {8626,8627,{8628,8629},{8630,8631}},
		[14]= {8632,8634,{8635,8636},{8637,8638}},
	}

	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find("SoO Progression");
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("SoO Progression:");
	end
	local op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][4][1]) ~= "--") or (GetComparisonStatistic(OSTAT[i][4][2]) ~= "--") then
			op = op + 1;
		end
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/14 |r|cFFFFFFFFMythic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 14 do
		if (GetComparisonStatistic(OSTAT[i][3][1]) ~= "--") or (GetComparisonStatistic(OSTAT[i][3][2]) ~= "--") then
			op = op + 1;
		end
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/14 |r|cFFFFFFFFHeroic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 14 do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/14 |r|cFFFFFFFFNormal ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 14 do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/14 |r|cFFFFFFFFLFR ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00none";
	end
	if not omatch then
		if progression ~= "" then
			GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
			GameTooltip:AddLine(progression);
		end
	else
		_G["GameTooltipTextLeft"..matchi]:SetText(progression);
	end
	if GameTooltip:GetWidth() < 140 then
		GameTooltip:SetWidth(140)
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	ClearAchievementComparisonUnit();
end	

function OGetHighmaul()
	local OSTAT = {
	--	[#] =  LFR,Normal,Heroic,Mythic
		[1] = {9280,9282,9284,9285},
		[2] = {9286,9287,9288,9289},
		[3] = {9290,9292,9293,9294},
		[4] = {9295,9297,9298,9300},
		[5] = {9301,9302,9303,9304},
		[6] = {9306,9308,9310,9311},
		[7] = {9312,9313,9314,9315},
	}
	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find("Highmaul Progression");
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("Highmaul Progression:");
	end
	local op=0;
	for i = 1, 7 do
		if GetComparisonStatistic(OSTAT[i][4]) ~= "--" then
			op = op + 1;
		end
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/7 |r|cFFFFFFFFMythic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 7 do
		if GetComparisonStatistic(OSTAT[i][3]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/7 |r|cFFFFFFFFHeroic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 7 do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/7 |r|cFFFFFFFFNormal ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 7 do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/7 |r|cFFFFFFFFLFR ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00none";
	end
	if not omatch then
		if progression ~= "" then
			GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
			GameTooltip:AddLine(progression);
		end
	else
		_G["GameTooltipTextLeft"..matchi]:SetText(progression);
	end
	if GameTooltip:GetWidth() < 140 then
		GameTooltip:SetWidth(140)
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	ClearAchievementComparisonUnit();
end

function OGetBF()
	local OSTAT = {
	---	[#] = LFR,Normal,Heroic,Mythic
		[1] = {9316,9317,9318,9319},
		[2] = {9320,9321,9322,9323},
		[3] = {9334,9336,9337,9338},
		[4] = {9330,9331,9332,9333},
		[5] = {9324,9327,9328,9329},
		[6] = {9339,9340,9341,9342},
		[7] = {9343,9349,9351,9353},
		[8] = {9354,9355,9356,9357},
		[9] = {9358,9359,9360,9361},
		[10] = {9362,9363,9364,9365},
	}
	local i=0;
	local omatch=false; -- check if some word repeat
	local twohighest=0;
	local progression="";
	local matchi=0; -- line that word repeat + 1
	for i = 2, GameTooltip:NumLines() do
		local msg = _G["GameTooltipTextLeft"..i]:GetText();
		if msg then
			msg = msg:find("BF Progression");
		end
		if msg then
			omatch=true;
			matchi=i+1;
			break;
		end
	end	
	if not omatch then
		GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
		GameTooltip:AddLine("BF Progression:");
	end
	local op=0;
	for i = 1, 10 do
		if GetComparisonStatistic(OSTAT[i][4]) ~= "--" then
			op = op + 1;
		end
	end	
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/10 |r|cFFFFFFFFMythic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 10 do
		if GetComparisonStatistic(OSTAT[i][3]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 then
		progression=progression.."|cFF00FF00"..op.."/10 |r|cFFFFFFFFHeroic ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 10 do
		if GetComparisonStatistic(OSTAT[i][2]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/10 |r|cFFFFFFFFNormal ";
		twohighest = twohighest + 1
	end
	op=0;
	for i = 1, 10 do
		if GetComparisonStatistic(OSTAT[i][1]) ~= "--" then
			op = op + 1;
		end
	end
	if op > 0 and twohighest < 2 then
		progression=progression.."|cFF00FF00"..op.."/10 |r|cFFFFFFFFLFR ";
		twohighest = twohighest + 1
	end
	if twohighest == 0 then
		progression=progression.."|cFF00FF00none";
	end
	if not omatch then
		if progression ~= "" then
			GameTooltip:SetHeight(GameTooltip:GetHeight()+15);
			GameTooltip:AddLine(progression);
		end
	else
		_G["GameTooltipTextLeft"..matchi]:SetText(progression);
	end
	if GameTooltip:GetWidth() < 140 then
		GameTooltip:SetWidth(140)
	end
	OILVL:UnregisterEvent("INSPECT_ACHIEVEMENT_READY");
	ClearAchievementComparisonUnit();
end

function OTgathertil(guid, unitid)
	local totalIlvl, avgIlvl = 0
	local iter_min, iter_max = 0
	local itemLevel = 0
	local equipType = 0
	local twoHander = nil
	local mia = 0;
	local count = 0
	for i = 1,17 do
		if(i ~= SHIRT) then
			local item = GetInventoryItemLink(unitid, i)
			if(item) then
				local upgradeID = ItemUpgradeInfo:GetUpgradeID(item)
				local upgrade = ItemUpgradeInfo:GetCurrentUpgrade(upgradeID)
				_,_,_,itemLevel,_,_,_,_,equipType = GetItemInfo(item)

				if(itemLevel) then
					count = count + 1
					if(i == WEP) then
						if(equipType == "INVTYPE_2HWEAPON" or equipType == "INVTYPE_RANGED" or equipType == "INVTYPE_RANGEDRIGHT") then
							twoHander = 1
						end
					end

					if(upgrade == 1) then 
						itemLevel = itemLevel + 4
					elseif(upgrade == 2) then
						itemLevel = itemLevel + 8
					elseif(upgrade == 3) then
						itemLevel = itemLevel + 12
					elseif(upgrade == 4) then
						itemLevel = itemLevel + 16
					end
					totalIlvl = totalIlvl + itemLevel
				end
			end
		end
	end
	if count < 15 and twoHander then
		mia = 1;
	end
	if count < 16 and not twoHander then
		mia = 1;
	end
	if((count == 15) and twoHander) then
		avgIlvl = round(totalIlvl / count,1)
	elseif((count == 16) and not twoHander) then
		avgIlvl = round(totalIlvl / count, 1)
	elseif((count == 16) and twoHander) then
		avgIlvl = round(totalIlvl / 16, 1)
	else
		avgIlvl = round(totalIlvl / 15, 1)
	end
return avgIlvl, mia;
end

function OTInspect(self,event,unit,role)
	if UnitAffectingCombat("player") == false and event ~= "PLAYER_LEAVING_WORLD" then
		if event == "INSPECT_READY" then
			if OILVL_Unit ~= "" then				
				if CheckInteractDistance(OILVL_Unit, 1) then
					OTilvl, OTmia = OTgathertil(UnitGUID("OILVL_Unit"),OILVL_Unit)
					if (OTmia == 0) then
						miacount=0;
						miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
						OILVL_Unit="";
						local ntex4 = _G[OTCurrent]:CreateTexture()
						ntex4:SetTexture(0.2,0.2,0.2,0.5)
						ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
						ntex4:SetAllPoints()	
						_G[OTCurrent]:SetNormalTexture(ntex4)
						if oilvlframedata.name[OTCurrent3] ~= "" then
							_G[OTCurrent]:SetText("|cFFFFFF00"..oilvlframedata.name[OTCurrent3].."\n|r|cFF00FF00"..OTilvl);
							oilvlframedata.ilvl[OTCurrent3] = OTilvl;
						end
						OTCurrent = "";
						OTCurrent2 = "";
						OTCurrent3 = "";
						ountrack=true;
					else
						miacount = miacount + 1
						miaunit[miacount] = UnitGUID("OILVL_Unit");
						if miaunit[1] == miaunit[2] and miaunit[2] == miaunit[3] and miaunit[3] == miaunit[4] and miaunit[4] == miaunit[5] and miaunit[5] == miaunit[6] then
							miacount=0;
							miaunit[1]="";miaunit[2]="";miaunit[3]="";miaunit[4]="";miaunit[5]="";miaunit[6]="";
							OILVL_Unit="";
							local ntex4 = _G[OTCurrent]:CreateTexture()
							ntex4:SetTexture(0.2,0.2,0.2,0.5)
							ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
							ntex4:SetAllPoints()	
							_G[OTCurrent]:SetNormalTexture(ntex4)
							if oilvlframedata.name[OTCurrent3] ~= "" then
								_G[OTCurrent]:SetText("|cFFFFFF00"..oilvlframedata.name[OTCurrent3].."\n|r|cFFFF0000"..OTilvl);
								oilvlframedata.ilvl[OTCurrent3] = OTilvl;
							end
							OTCurrent = "";
							OTCurrent2 = "";
							OTCurrent3 = "";
							ountrack=true;						
						end
					end
				else
					OILVL_Unit="";
					local ntex4 = _G[OTCurrent]:CreateTexture()
					ntex4:SetTexture(0.2,0.2,0.2,0.5)
					ntex4:SetTexCoord(0, 0.625, 0, 0.6875)
					ntex4:SetAllPoints()	
					_G[OTCurrent]:SetNormalTexture(ntex4)
					OTCurrent = "";
					OTCurrent2 = "";
					OTCurrent3 = "";
					ountrack=true;
				end	
			end
			-- GameTooltip		
			if (Omover ==1) then
				Omover=0;				
				if CheckInteractDistance("mouseover", 1) then
					local OTilvl2, OTmia2 = OTgathertil(UnitGUID("mouseover"),"mouseover")
					if (OTmia2 == 0) then
						local i=0;
						local omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Item Level: |r|cFF00FF00"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Item Level: |r|cFF00FF00"..OTilvl2);	
						end
					else
						local i=0;
						local omatch=false;
						for i = 2, GameTooltip:NumLines() do
							local msg = _G["GameTooltipTextLeft"..i]:GetText();
							if msg then
								msg = msg:find("Item Level");
							end						
							if msg then
								_G["GameTooltipTextLeft"..i]:SetText("Item Level: |r|cFFFF0000"..OTilvl2);
								omatch=true;
								break;
							end
						end	
						if not omatch then
							GameTooltip:SetHeight(GameTooltip:GetHeight()+10);
							GameTooltip:AddLine("Item Level: |r|cFFFF0000"..OTilvl2);	
						end
						Oilvltimer:ScheduleTimer(OMouseover,1);
					end
				end
			end
			OILVL:UnregisterEvent("INSPECT_READY")
			ClearInspectPlayer()
		end
		if event == "INSPECT_ACHIEVEMENT_READY" then
--			OGetComA(); 
			OGetHighmaul();	
			OGetBF();	
		end
		if event == "GROUP_ROSTER_UPDATE" then
			--OVILRefresh();
			OilvlCheckFrame();
		end
		if event == "RAID_ROSTER_UPDATE" then
			--OVILRefresh();
			OilvlCheckFrame();
		end
		if event == "PLAYER_EQUIPMENT_CHANGED" then
			ORfbIlvl(1);
		end
		if event == "VARIABLES_LOADED" then
			cfg = Oilvl_Settings;
			if not cfg.oilvlframeP then cfg.oilvlframeP = "TOPLEFT"; end
			if not cfg.oilvlframeX then cfg.oilvlframeX = 15; end
			if not cfg.oilvlframeY then cfg.oilvlframeY = -60; end
			if not cfg.oilvlscale  then cfg.oilvlscale = 0.8; end
			if not cfg.oilvlalpha  then cfg.oilvlalpha = 1; end
		end
		if event == "PLAYER_LOGIN" then			
			OilvlConfigFrame();
			oilvlframe();
			Oilvltimer:ScheduleTimer(OVILRefresh,2);
			Oilvltimer:ScheduleRepeatingTimer(oilvlcheckrange,1);
		end
		if event == "PLAYER_ENTERING_WORLD" then
			--OVILRefresh();
			Oilvltimer:ScheduleTimer(OilvlCheckFrame,10);
		end
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		local nn=1;
		for nn=1, 40 do
			_G["OILVLRAIDFRAME"..nn]:Disable();
		end
		OILVLREFRESH:Hide();
	end
	
	if event == "PLAYER_REGEN_ENABLED" then
		local nn=1;
		for nn=1, 40 do
			_G["OILVLRAIDFRAME"..nn]:Enable();
		end
		OILVLREFRESH:Show();
		OilvlCheckFrame();
	end	
	
	if event == "ROLE_CHANGED_INFORM" then
		if IsInRaid() then
			local rnum = GetNumGroupMembers();
			local i = 1;
			for i = 1, rnum do
				if GetUnitName("raid"..i,true) == self then
					OilvlSetRole(i, role);
				end
			end
		elseif IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
			local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_INSTANCE)
			if GetUnitName("player",true) == self then
				OilvlSetRole(1, role);
			end
			local i = 2;
			for i = 2, rnum do
				if GetUnitName("party"..(i-1),true) == self then
					OilvlSetRole(i, role);
				end
			end
		elseif IsInGroup(LE_PARTY_CATEGORY_HOME) then
			local rnum = GetNumGroupMembers(LE_PARTY_CATEGORY_HOME)
			if GetUnitName("player",true) == self then
				OilvlSetRole(1, role);
			end
			local i = 2;
			for i = 2, rnum do
				if GetUnitName("party"..(i-1),true) == self then
					OilvlSetRole(i, role);
				end
			end
		end		
	end
	
	if event =="LFG_ROLE_UPDATE" or event == "PLAYER_SPECIALIZATION_CHANGED" then
		OILVLCheckUpdate();		
	end
end
	-- Set GameTooltip	
function OMouseover()
	if not UnitAffectingCombat("player") then
		if CheckInteractDistance("mouseover", 1) and CanInspect("mouseover") then
			OILVL:RegisterEvent("INSPECT_READY");
			NotifyInspect("mouseover");
			Omover=1;
			ClearAchievementComparisonUnit();
			SetAchievementComparisonUnit("mouseover");
			OILVL:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		end
	end
end

function OilvlConfigFrame()
	cfg.frame = CreateFrame("Frame",addon.."Config",InterfaceOptionsFramePanelContainer)
	cfg.frame.name = "O Item Level"
	InterfaceOptions_AddCategory(cfg.frame)

	local title = cfg.frame:CreateFontString(nil,"ARTWORK","GameFontNormalLarge")
	title:SetPoint("TOPLEFT",16,-16)
	title:SetText("O Item Level "..GetAddOnMetadata("Oilvl","Version")) -- can get version from GetAddOnMetadata
	
--  oilvl scale
	local oscale = CreateFrame("Slider", "Oilvlscale", cfg.frame, "OptionsSliderTemplate")
	oscale:SetWidth(200)
	oscale:SetHeight(20)
	oscale:SetOrientation('HORIZONTAL');
	oscale:SetPoint("TOPLEFT",16,-70);
	
	local scaletitle = oscale:CreateFontString(nil,"ARTWORK","GameFontNormal")
	scaletitle:SetPoint("LEFT",oscale,"LEFT",0,35)
	scaletitle:SetText("O Item Level Frame");

	getglobal(oscale:GetName() .. 'Low'):SetText('1'); --Sets the left-side slider text (default is "Low").
	getglobal(oscale:GetName() .. 'High'):SetText('100'); --Sets the right-side slider text (default is "High").
	getglobal(oscale:GetName() .. 'Text'):SetText('Scale'); --Sets the "title" text (top-centre of slider).
	
	oscale:SetMinMaxValues(0, 1);
	oscale:SetValue(cfg.oilvlscale);
	oscale:RegisterForDrag("LeftButton");
	oscale:SetScript("OnDragStop", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	oscale:SetScript("OnMouseDown", function(self, button) 
	local n=oscale:GetValue(); 
		if n > 0 then 
			OIVLFRAME:SetScale(n) 
			cfg.oilvlscale = n;
		end
	end);
	
--  oilvl transparent
	local oalpha = CreateFrame("Slider", "Oilvlalpha", cfg.frame, "OptionsSliderTemplate")
	oalpha:SetWidth(200)
	oalpha:SetHeight(20)
	oalpha:SetOrientation('HORIZONTAL');
	oalpha:SetPoint("TOPLEFT",16,-120);
	
	getglobal(oalpha:GetName() .. 'Low'):SetText('0'); --Sets the left-side slider text (default is "Low").
	getglobal(oalpha:GetName() .. 'High'):SetText('1'); --Sets the right-side slider text (default is "High").
	getglobal(oalpha:GetName() .. 'Text'):SetText('Transparency'); --Sets the "title" text (top-centre of slider).
	
	oalpha:SetMinMaxValues(0, 1);
	oalpha:SetValue(cfg.oilvlalpha);
	oalpha:RegisterForDrag("LeftButton");	
	oalpha:SetScript("OnMouseDown", function(self, button) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
	oalpha:SetScript("OnDragStop", function(self) 
	local n=oalpha:GetValue(); 
		OIVLFRAME:SetAlpha(n) 
		cfg.oilvlalpha = n;
	end);
end

--[[Fix for Lua errors with Blizzard_AchievementUI below]]--
local unregistered,reregistered
local function reregisterBlizz()
	if not reregistered then
		AchievementFrameComparison:RegisterEvent("INSPECT_ACHIEVEMENT_READY")
		reregistered=true
	end
end
local function unregisterBlizz(name)
	if not unregistered then
		if not name or name=="Blizzard_AchievementUI" then
			AchievementFrameComparison:UnregisterEvent("INSPECT_ACHIEVEMENT_READY")
			hooksecurefunc("InspectAchievements",reregisterBlizz)
			unregistered=true
		end
	end
end
if IsAddOnLoaded("Blizzard_AchievementUI") then
	unregisterBlizz()
else
	hooksecurefunc("LoadAddOn",unregisterBlizz)
end
------------------------------------------------------------------

SLASH_OILVL_OILVL1 = "/oilvl"

SlashCmdList["OILVL_OILVL"] = function()
		OIVLFRAME:ClearAllPoints();
		OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
		OIVLFRAME:SetScale(cfg.oilvlscale);
		OIVLFRAME:SetAlpha(cfg.oilvlalpha);
		OIVLFRAME:Show();
	end

SLASH_OILVL_OI1 = "/oi"

SlashCmdList["OILVL_OI"] = function()
		OIVLFRAME:ClearAllPoints();
		OIVLFRAME:SetPoint(cfg.oilvlframeP, cfg.oilvlframeX, cfg.oilvlframeY);
		OIVLFRAME:SetScale(cfg.oilvlscale);
		OIVLFRAME:SetAlpha(cfg.oilvlalpha);
		OIVLFRAME:Show();
	end


OILVL:SetScript("OnEvent", OTInspect)
OILVL:RegisterEvent("PLAYER_LEAVING_WORLD");
OILVL:RegisterEvent("GROUP_ROSTER_UPDATE");
OILVL:RegisterEvent("RAID_ROSTER_UPDATE");
OILVL:RegisterEvent("VARIABLES_LOADED");
OILVL:RegisterEvent("PLAYER_EQUIPMENT_CHANGED");
OILVL:RegisterEvent("PLAYER_LOGIN");
OILVL:RegisterEvent("PLAYER_ENTERING_WORLD");
OILVL:RegisterEvent("PLAYER_REGEN_DISABLED");
OILVL:RegisterEvent("PLAYER_REGEN_ENABLED");
OILVL:RegisterEvent("ROLE_CHANGED_INFORM");
OILVL:RegisterEvent("LFG_ROLE_UPDATE");
OILVL:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED");

GameTooltip:HookScript("OnTooltipSetUnit", function() Oilvltimer:ScheduleTimer(OMouseover,1); end);